helpers.mk 15 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405
  1. # This Makefile fragment declares toolchain related helper functions.
  2. # The copy_toolchain_lib_root function copies a toolchain library and
  3. # its symbolic links from the sysroot directory to the target
  4. # directory. Note that this function is used both by the external
  5. # toolchain logic, and the glibc package, so care must be taken when
  6. # changing this function.
  7. #
  8. # Most toolchains (CodeSourcery ones) have their libraries either in
  9. # /lib or /usr/lib relative to their ARCH_SYSROOT_DIR, so we search
  10. # libraries in:
  11. #
  12. # $${ARCH_LIB_DIR}
  13. # usr/$${ARCH_LIB_DIR}
  14. #
  15. # Buildroot toolchains, however, have basic libraries in /lib, and
  16. # libstdc++/libgcc_s in /usr/<target-name>/lib(64), so we also need to
  17. # search libraries in:
  18. #
  19. # usr/$(TOOLCHAIN_EXTERNAL_PREFIX)/$${ARCH_LIB_DIR}
  20. #
  21. # Linaro toolchains have most libraries in lib/<target-name>/, so we
  22. # need to search libraries in:
  23. #
  24. # $${ARCH_LIB_DIR}/$(TOOLCHAIN_EXTERNAL_PREFIX)
  25. #
  26. # And recent Linaro toolchains have the GCC support libraries
  27. # (libstdc++, libgcc_s, etc.) into a separate directory, outside of
  28. # the sysroot, that we called the "SUPPORT_LIB_DIR", into which we
  29. # need to search as well.
  30. #
  31. # Thanks to ARCH_LIB_DIR we also take into account toolchains that
  32. # have the libraries in lib64 and usr/lib64.
  33. #
  34. # Please be very careful to check the major toolchain sources:
  35. # Buildroot, Crosstool-NG, CodeSourcery and Linaro before doing any
  36. # modification on the below logic.
  37. #
  38. # $1: arch specific sysroot directory
  39. # $2: support libraries directory (can be empty)
  40. # $3: library directory ('lib' or 'lib64') from which libraries must be copied
  41. # $4: library name
  42. # $5: destination directory of the libary, relative to $(TARGET_DIR)
  43. #
  44. copy_toolchain_lib_root = \
  45. ARCH_SYSROOT_DIR="$(strip $1)"; \
  46. SUPPORT_LIB_DIR="$(strip $2)" ; \
  47. ARCH_LIB_DIR="$(strip $3)" ; \
  48. LIB="$(strip $4)"; \
  49. DESTDIR="$(strip $5)" ; \
  50. \
  51. for dir in \
  52. $${ARCH_SYSROOT_DIR}/$${ARCH_LIB_DIR}/$(TOOLCHAIN_EXTERNAL_PREFIX) \
  53. $${ARCH_SYSROOT_DIR}/usr/$(TOOLCHAIN_EXTERNAL_PREFIX)/$${ARCH_LIB_DIR} \
  54. $${ARCH_SYSROOT_DIR}/$${ARCH_LIB_DIR} \
  55. $${ARCH_SYSROOT_DIR}/usr/$${ARCH_LIB_DIR} \
  56. $${SUPPORT_LIB_DIR} ; do \
  57. LIBSPATH=`find $${dir} -maxdepth 1 -name "$${LIB}" 2>/dev/null` ; \
  58. if test -n "$${LIBSPATH}" ; then \
  59. break ; \
  60. fi \
  61. done ; \
  62. mkdir -p $(TARGET_DIR)/$${DESTDIR}; \
  63. for LIBPATH in $${LIBSPATH} ; do \
  64. while true ; do \
  65. LIBNAME=`basename $${LIBPATH}`; \
  66. LIBDIR=`dirname $${LIBPATH}` ; \
  67. LINKTARGET=`readlink $${LIBPATH}` ; \
  68. rm -fr $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME}; \
  69. if test -h $${LIBPATH} ; then \
  70. ln -sf `basename $${LINKTARGET}` $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME} ; \
  71. elif test -f $${LIBPATH}; then \
  72. $(INSTALL) -D -m0755 $${LIBPATH} $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME}; \
  73. else \
  74. exit -1; \
  75. fi; \
  76. if test -z "$${LINKTARGET}" ; then \
  77. break ; \
  78. fi ; \
  79. LIBPATH="`readlink -f $${LIBPATH}`"; \
  80. done; \
  81. done
  82. #
  83. # Copy the full external toolchain sysroot directory to the staging
  84. # dir. The operation of this function is rendered a little bit
  85. # complicated by the support for multilib toolchains.
  86. #
  87. # We start by copying etc, lib, sbin and usr from the sysroot of the
  88. # selected architecture variant (as pointed by ARCH_SYSROOT_DIR). This
  89. # allows to import into the staging directory the C library and
  90. # companion libraries for the correct architecture variant. We
  91. # explictly only copy etc, lib, sbin and usr since other directories
  92. # might exist for other architecture variants (on Codesourcery
  93. # toolchain, the sysroot for the default architecture variant contains
  94. # the armv4t and thumb2 subdirectories, which are the sysroot for the
  95. # corresponding architecture variants), and we don't want to import
  96. # them.
  97. #
  98. # Then, if the selected architecture variant is not the default one
  99. # (i.e, if SYSROOT_DIR != ARCH_SYSROOT_DIR), then we :
  100. #
  101. # * Import the header files from the default architecture
  102. # variant. Header files are typically shared between the sysroots
  103. # for the different architecture variants. If we use the
  104. # non-default one, header files were not copied by the previous
  105. # step, so we copy them here from the sysroot of the default
  106. # architecture variant.
  107. #
  108. # * Create a symbolic link that matches the name of the subdirectory
  109. # for the architecture variant in the original sysroot. This is
  110. # required as the compiler will by default look in
  111. # sysroot_dir/arch_variant/ for libraries and headers, when the
  112. # non-default architecture variant is used. Without this, the
  113. # compiler fails to find libraries and headers.
  114. #
  115. # Some toolchains (i.e Linaro binary toolchains) store support
  116. # libraries (libstdc++, libgcc_s) outside of the sysroot, so we simply
  117. # copy all the libraries from the "support lib directory" into our
  118. # sysroot.
  119. #
  120. # Note that the 'locale' directories are not copied. They are huge
  121. # (400+MB) in CodeSourcery toolchains, and they are not really useful.
  122. #
  123. # $1: main sysroot directory of the toolchain
  124. # $2: arch specific sysroot directory of the toolchain
  125. # $3: arch specific subdirectory in the sysroot
  126. # $4: directory of libraries ('lib', 'lib32' or 'lib64')
  127. # $5: support lib directories (for toolchains storing libgcc_s,
  128. # libstdc++ and other gcc support libraries outside of the
  129. # sysroot)
  130. copy_toolchain_sysroot = \
  131. SYSROOT_DIR="$(strip $1)"; \
  132. ARCH_SYSROOT_DIR="$(strip $2)"; \
  133. ARCH_SUBDIR="$(strip $3)"; \
  134. ARCH_LIB_DIR="$(strip $4)" ; \
  135. SUPPORT_LIB_DIR="$(strip $5)" ; \
  136. for i in etc $${ARCH_LIB_DIR} sbin usr usr/$${ARCH_LIB_DIR}; do \
  137. if [ -d $${ARCH_SYSROOT_DIR}/$$i ] ; then \
  138. rsync -au --chmod=u=rwX,go=rX --exclude 'usr/lib/locale' \
  139. --exclude lib --exclude lib32 --exclude lib64 \
  140. $${ARCH_SYSROOT_DIR}/$$i/ $(STAGING_DIR)/$$i/ ; \
  141. fi ; \
  142. done ; \
  143. if [ `readlink -f $${SYSROOT_DIR}` != `readlink -f $${ARCH_SYSROOT_DIR}` ] ; then \
  144. if [ ! -d $${ARCH_SYSROOT_DIR}/usr/include ] ; then \
  145. cp -a $${SYSROOT_DIR}/usr/include $(STAGING_DIR)/usr ; \
  146. fi ; \
  147. mkdir -p `dirname $(STAGING_DIR)/$${ARCH_SUBDIR}` ; \
  148. relpath="./" ; \
  149. nbslashs=`printf $${ARCH_SUBDIR} | sed 's%[^/]%%g' | wc -c` ; \
  150. for slash in `seq 1 $${nbslashs}` ; do \
  151. relpath=$${relpath}"../" ; \
  152. done ; \
  153. ln -s $${relpath} $(STAGING_DIR)/$${ARCH_SUBDIR} ; \
  154. echo "Symlinking $(STAGING_DIR)/$${ARCH_SUBDIR} -> $${relpath}" ; \
  155. fi ; \
  156. if test -n "$${SUPPORT_LIB_DIR}" ; then \
  157. cp -a $${SUPPORT_LIB_DIR}/* $(STAGING_DIR)/lib/ ; \
  158. fi ; \
  159. find $(STAGING_DIR) -type d | xargs chmod 755
  160. #
  161. # Check the specified kernel headers version actually matches the
  162. # version in the toolchain.
  163. #
  164. # $1: sysroot directory
  165. # $2: kernel version string, in the form: X.Y
  166. #
  167. check_kernel_headers_version = \
  168. if ! support/scripts/check-kernel-headers.sh $(1) $(2); then \
  169. exit 1; \
  170. fi
  171. #
  172. # Check the specific gcc version actually matches the version in the
  173. # toolchain
  174. #
  175. # $1: path to gcc
  176. # $2: expected gcc version
  177. #
  178. # Some details about the sed expression:
  179. # - 1!d
  180. # - delete if not line 1
  181. #
  182. # - s/^[^)]+\) ([^[:space:]]+).*/\1/
  183. # - eat all until the first ')' character followed by a space
  184. # - match as many non-space chars as possible
  185. # - eat all the remaining chars on the line
  186. # - replace by the matched expression
  187. #
  188. check_gcc_version = \
  189. expected_version="$(strip $2)" ; \
  190. if [ -z "$${expected_version}" ]; then \
  191. printf "Internal error, gcc version unknown (no GCC_AT_LEAST_X_Y selected)\n"; \
  192. exit 1 ; \
  193. fi; \
  194. real_version=`$(1) --version | sed -r -e '1!d; s/^[^)]+\) ([^[:space:]]+).*/\1/;'` ; \
  195. if [[ ! "$${real_version}" =~ ^$${expected_version}\. ]] ; then \
  196. printf "Incorrect selection of gcc version: expected %s.x, got %s\n" \
  197. "$${expected_version}" "$${real_version}" ; \
  198. exit 1 ; \
  199. fi
  200. #
  201. # Check the availability of a particular glibc feature. This function
  202. # is used to check toolchain options that are always supported by
  203. # glibc, so we simply check that the corresponding option is properly
  204. # enabled.
  205. #
  206. # $1: Buildroot option name
  207. # $2: feature description
  208. #
  209. check_glibc_feature = \
  210. if [ "$($(1))" != "y" ] ; then \
  211. echo "$(2) available in C library, please enable $(1)" ; \
  212. exit 1 ; \
  213. fi
  214. #
  215. # Check the availability of RPC support in a glibc toolchain
  216. #
  217. # $1: sysroot directory
  218. #
  219. check_glibc_rpc_feature = \
  220. IS_IN_LIBC=`test -f $(1)/usr/include/rpc/rpc.h && echo y` ; \
  221. if [ "$(BR2_TOOLCHAIN_HAS_NATIVE_RPC)" != "y" -a "$${IS_IN_LIBC}" = "y" ] ; then \
  222. echo "RPC support available in C library, please enable BR2_TOOLCHAIN_EXTERNAL_INET_RPC" ; \
  223. exit 1 ; \
  224. fi ; \
  225. if [ "$(BR2_TOOLCHAIN_HAS_NATIVE_RPC)" = "y" -a "$${IS_IN_LIBC}" != "y" ] ; then \
  226. echo "RPC support not available in C library, please disable BR2_TOOLCHAIN_EXTERNAL_INET_RPC" ; \
  227. exit 1 ; \
  228. fi
  229. #
  230. # Check the correctness of a glibc external toolchain configuration.
  231. # 1. Check that the C library selected in Buildroot matches the one
  232. # of the external toolchain
  233. # 2. Check that all the C library-related features are enabled in the
  234. # config, since glibc always supports all of them
  235. #
  236. # $1: sysroot directory
  237. #
  238. check_glibc = \
  239. SYSROOT_DIR="$(strip $1)"; \
  240. if test `find $${SYSROOT_DIR}/ -maxdepth 2 -name 'ld-linux*.so.*' -o -name 'ld.so.*' -o -name 'ld64.so.*' | wc -l` -eq 0 ; then \
  241. echo "Incorrect selection of the C library"; \
  242. exit -1; \
  243. fi; \
  244. $(call check_glibc_feature,BR2_USE_MMU,MMU support) ;\
  245. $(call check_glibc_rpc_feature,$${SYSROOT_DIR})
  246. #
  247. # Check that the selected C library really is musl
  248. #
  249. # $1: sysroot directory
  250. check_musl = \
  251. SYSROOT_DIR="$(strip $1)"; \
  252. if test ! -f $${SYSROOT_DIR}/lib/libc.so -o -e $${SYSROOT_DIR}/lib/libm.so ; then \
  253. echo "Incorrect selection of the C library" ; \
  254. exit -1; \
  255. fi
  256. #
  257. # Check the conformity of Buildroot configuration with regard to the
  258. # uClibc configuration of the external toolchain, for a particular
  259. # feature.
  260. #
  261. # If 'Buildroot option name' ($2) is empty it means the uClibc option
  262. # is mandatory.
  263. #
  264. # $1: uClibc macro name
  265. # $2: Buildroot option name
  266. # $3: uClibc config file
  267. # $4: feature description
  268. #
  269. check_uclibc_feature = \
  270. IS_IN_LIBC=`grep -q "\#define $(1) 1" $(3) && echo y` ; \
  271. if [ -z "$(2)" ] ; then \
  272. if [ "$${IS_IN_LIBC}" != "y" ] ; then \
  273. echo "$(4) not available in C library, toolchain unsuitable for Buildroot" ; \
  274. exit 1 ; \
  275. fi ; \
  276. else \
  277. if [ "$($(2))" != "y" -a "$${IS_IN_LIBC}" = "y" ] ; then \
  278. echo "$(4) available in C library, please enable $(2)" ; \
  279. exit 1 ; \
  280. fi ; \
  281. if [ "$($(2))" = "y" -a "$${IS_IN_LIBC}" != "y" ] ; then \
  282. echo "$(4) not available in C library, please disable $(2)" ; \
  283. exit 1 ; \
  284. fi ; \
  285. fi
  286. #
  287. # Check the correctness of a uclibc external toolchain configuration
  288. # 1. Check that the C library selected in Buildroot matches the one
  289. # of the external toolchain
  290. # 2. Check that the features enabled in the Buildroot configuration
  291. # match the features available in the uClibc of the external
  292. # toolchain
  293. #
  294. # $1: sysroot directory
  295. #
  296. check_uclibc = \
  297. SYSROOT_DIR="$(strip $1)"; \
  298. if ! test -f $${SYSROOT_DIR}/usr/include/bits/uClibc_config.h ; then \
  299. echo "Incorrect selection of the C library"; \
  300. exit -1; \
  301. fi; \
  302. UCLIBC_CONFIG_FILE=$${SYSROOT_DIR}/usr/include/bits/uClibc_config.h ; \
  303. $(call check_uclibc_feature,__ARCH_USE_MMU__,BR2_USE_MMU,$${UCLIBC_CONFIG_FILE},MMU support) ;\
  304. $(call check_uclibc_feature,__UCLIBC_HAS_LFS__,,$${UCLIBC_CONFIG_FILE},Large file support) ;\
  305. $(call check_uclibc_feature,__UCLIBC_HAS_IPV6__,,$${UCLIBC_CONFIG_FILE},IPv6 support) ;\
  306. $(call check_uclibc_feature,__UCLIBC_HAS_RPC__,BR2_TOOLCHAIN_HAS_NATIVE_RPC,$${UCLIBC_CONFIG_FILE},RPC support) ;\
  307. $(call check_uclibc_feature,__UCLIBC_HAS_LOCALE__,BR2_ENABLE_LOCALE,$${UCLIBC_CONFIG_FILE},Locale support) ;\
  308. $(call check_uclibc_feature,__UCLIBC_HAS_WCHAR__,BR2_USE_WCHAR,$${UCLIBC_CONFIG_FILE},Wide char support) ;\
  309. $(call check_uclibc_feature,__UCLIBC_HAS_THREADS__,BR2_TOOLCHAIN_HAS_THREADS,$${UCLIBC_CONFIG_FILE},Thread support) ;\
  310. $(call check_uclibc_feature,__PTHREADS_DEBUG_SUPPORT__,BR2_TOOLCHAIN_HAS_THREADS_DEBUG,$${UCLIBC_CONFIG_FILE},Thread debugging support) ;\
  311. $(call check_uclibc_feature,__UCLIBC_HAS_THREADS_NATIVE__,BR2_TOOLCHAIN_HAS_THREADS_NPTL,$${UCLIBC_CONFIG_FILE},NPTL thread support) ;\
  312. $(call check_uclibc_feature,__UCLIBC_HAS_SSP__,BR2_TOOLCHAIN_HAS_SSP,$${UCLIBC_CONFIG_FILE},Stack Smashing Protection support)
  313. #
  314. # Check that the Buildroot configuration of the ABI matches the
  315. # configuration of the external toolchain.
  316. #
  317. # $1: cross-gcc path
  318. # $2: cross-readelf path
  319. #
  320. check_arm_abi = \
  321. __CROSS_CC=$(strip $1) ; \
  322. __CROSS_READELF=$(strip $2) ; \
  323. EXT_TOOLCHAIN_TARGET=`LANG=C $${__CROSS_CC} -v 2>&1 | grep ^Target | cut -f2 -d ' '` ; \
  324. if ! echo $${EXT_TOOLCHAIN_TARGET} | grep -qE 'eabi(hf)?$$' ; then \
  325. echo "External toolchain uses the unsuported OABI" ; \
  326. exit 1 ; \
  327. fi ; \
  328. if ! echo 'int main(void) {}' | $${__CROSS_CC} -x c -o $(BUILD_DIR)/.br-toolchain-test.tmp - ; then \
  329. rm -f $(BUILD_DIR)/.br-toolchain-test.tmp*; \
  330. abistr_$(BR2_ARM_EABI)='EABI'; \
  331. abistr_$(BR2_ARM_EABIHF)='EABIhf'; \
  332. echo "Incorrect ABI setting: $${abistr_y} selected, but toolchain is incompatible"; \
  333. exit 1 ; \
  334. fi ; \
  335. rm -f $(BUILD_DIR)/.br-toolchain-test.tmp*
  336. #
  337. # Check that the external toolchain supports C++
  338. #
  339. # $1: cross-g++ path
  340. #
  341. check_cplusplus = \
  342. __CROSS_CXX=$(strip $1) ; \
  343. $${__CROSS_CXX} -v > /dev/null 2>&1 ; \
  344. if test $$? -ne 0 ; then \
  345. echo "C++ support is selected but is not available in external toolchain" ; \
  346. exit 1 ; \
  347. fi
  348. #
  349. # Check that the cross-compiler given in the configuration exists
  350. #
  351. # $1: cross-gcc path
  352. #
  353. check_cross_compiler_exists = \
  354. __CROSS_CC=$(strip $1) ; \
  355. $${__CROSS_CC} -v > /dev/null 2>&1 ; \
  356. if test $$? -ne 0 ; then \
  357. echo "Cannot execute cross-compiler '$${__CROSS_CC}'" ; \
  358. exit 1 ; \
  359. fi
  360. #
  361. # Check for toolchains known not to work with Buildroot. For now, we
  362. # only check for Angstrom toolchains, by looking at the vendor part of
  363. # the host tuple.
  364. #
  365. # $1: cross-gcc path
  366. #
  367. check_unusable_toolchain = \
  368. __CROSS_CC=$(strip $1) ; \
  369. vendor=`$${__CROSS_CC} -dumpmachine | cut -f2 -d'-'` ; \
  370. if test "$${vendor}" = "angstrom" ; then \
  371. echo "Angstrom toolchains are not pure toolchains: they contain" ; \
  372. echo "many other libraries than just the C library, which makes" ; \
  373. echo "them unsuitable as external toolchains for build systems" ; \
  374. echo "such as Buildroot." ; \
  375. exit 1 ; \
  376. fi; \
  377. with_sysroot=`$${__CROSS_CC} -v 2>&1 |sed -r -e '/.* --with-sysroot=([^[:space:]]+)[[:space:]].*/!d; s//\1/'`; \
  378. if test "$${with_sysroot}" = "/" ; then \
  379. echo "Distribution toolchains are unsuitable for use by Buildroot," ; \
  380. echo "as they were configured in a way that makes them non-relocatable,"; \
  381. echo "and contain a lot of pre-built libraries that would conflict with"; \
  382. echo "the ones Buildroot wants to build."; \
  383. exit 1; \
  384. fi
  385. #
  386. # Generate gdbinit file for use with Buildroot
  387. #
  388. gen_gdbinit_file = \
  389. mkdir -p $(STAGING_DIR)/usr/share/buildroot/ ; \
  390. echo "set sysroot $(STAGING_DIR)" > $(STAGING_DIR)/usr/share/buildroot/gdbinit